package jp.strippers.remoting {

  public class ServiceFactory {

    private static var _instance:ServiceFactory;

    private var _gatewayUrl:String;
    private var _serviceMap:Object;

    public function ServiceFactory(arg:ServiceFactoryArgs) {
      _gatewayUrl = arg.gatewayUrl;
      _serviceMap = new Object();
    }

    public static function getInstance(gatewayUrl:String):ServiceFactory {
      if (ServiceFactory._instance == null) {
        ServiceFactory._instance = new ServiceFactory(new ServiceFactoryArgs(gatewayUrl));
      }
      return ServiceFactory._instance;	
    }

    public function getService(serviceName:String):RemotingService {
      var cacheKey:String = _gatewayUrl + serviceName;
      var service:RemotingService = _serviceMap[cacheKey];
      if (service) {
        return service;
      }
      var conn:RemotingConnection = getConnectionFromExistingService();
      if (conn) {
        service = new RemotingService(null, serviceName, conn);
      } else {
        service = new RemotingService(_gatewayUrl, serviceName);
      }	
      _serviceMap[cacheKey] = service;
      return service;
    }

    private function getConnectionFromExistingService():RemotingConnection {
      for each (var service:RemotingService in _serviceMap) {
        return service.connection as RemotingConnection;
      }
      return undefined;
    }

  }


}

class ServiceFactoryArgs {

  public var gatewayUrl:String;	

  public function ServiceFactoryArgs(gatewayUrl:String) {
    this.gatewayUrl = gatewayUrl;
  }

}
